<?php

namespace Lc\CaracoleBundle\Repository\Reminder;

use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Repository\Reminder\ReminderStore as SovReminderStore;

class ReminderStore extends SovReminderStore
{
    protected MerchantInterface $merchant;
    protected SectionInterface $section;

    public function setMerchant(MerchantInterface $merchant)
    {
        $this->merchant = $merchant;

        return $this;
    }

    public function setSection(SectionInterface $section)
    {
        $this->section = $section;

        return $this;
    }

    public function get($params = [], $query = null)
    {
        if(is_null($query)) {
            $query = $this->query->create();
        }

        if($this->merchant) {
            $query->filterByMerchant($this->merchant);
        }

        if($this->section) {
            $query->filterBySection($this->section);
        }

        return parent::get($params, $query);
    }

}
